searchData={"items":[{"type":"module","title":"Abacus","doc":"A math-expression parser, evaluator and formatter for Elixir.","ref":"Abacus.html"},{"type":"module","title":"Features - Abacus","doc":"","ref":"Abacus.html#module-features"},{"type":"module","title":"Supported operators - Abacus","doc":"- `+`, `-`, `/`, `*`\n - Exponentials with `^`\n - Factorial (`n!`)\n - Bitwise operators\n   * `<<` `>>` bitshift\n   * `&` bitwise and\n   * `|` bitwise or\n   * `|^` bitwise xor\n   * `~` bitwise not (unary)\n - Boolean operators\n   * `&&`, `||`, `not`\n   * `==`, `!=`, `>`, `>=`, `<`, `<=`\n   * Ternary `condition ? if_true : if_false`","ref":"Abacus.html#module-supported-operators"},{"type":"module","title":"Supported functions - Abacus","doc":"- `sin(x)`, `cos(x)`, `tan(x)`\n - `round(n, precision = 0)`, `ceil(n, precision = 0)`, `floor(n, precision = 0)`","ref":"Abacus.html#module-supported-functions"},{"type":"module","title":"Reserved words - Abacus","doc":"- `true`\n - `false`\n - `null`","ref":"Abacus.html#module-reserved-words"},{"type":"module","title":"Access to variables in scope - Abacus","doc":"- `a` with scope `%{\"a\" => 10}` would evaluate to `10`\n - `a.b` with scope `%{\"a\" => %{\"b\" => 42}}` would evaluate to `42`\n - `list[2]` with scope `%{\"list\" => [1, 2, 3]}` would evaluate to `3`","ref":"Abacus.html#module-access-to-variables-in-scope"},{"type":"module","title":"Data types - Abacus","doc":"- Boolean: `true`, `false`\n - None: `null`\n - Integer: `0`, `40`, `-184`\n - Float: `0.2`, `12.`, `.12`\n - String: `\"Hello World\"`, `\"He said: \"Let's write a math parser\"\"`\n\nIf a variable is not in the scope, `eval/2` will result in `{:error, error}`.","ref":"Abacus.html#module-data-types"},{"type":"function","title":"Abacus.compile/1","doc":"","ref":"Abacus.html#compile/1"},{"type":"function","title":"Abacus.eval/3","doc":"Evaluates the given expression with no scope.\n\nIf `expr` is a string, it will be parsed first.","ref":"Abacus.html#eval/3"},{"type":"function","title":"Abacus.eval!/1","doc":"Evaluates the given expression.\n\nRaises errors when parsing or evaluating goes wrong.","ref":"Abacus.html#eval!/1"},{"type":"function","title":"Abacus.eval!/2","doc":"Evaluates the given expression with the given scope.\n\nIf `expr` is a string, it will be parsed first.","ref":"Abacus.html#eval!/2"},{"type":"function","title":"Abacus.format/1","doc":"Pretty-prints the given expression.\n\nIf `expr` is a string, it will be parsed first.","ref":"Abacus.html#format/1"},{"type":"module","title":"Abacus.Compile","doc":"","ref":"Abacus.Compile.html"},{"type":"function","title":"Abacus.Compile.add_use_bitwise/1","doc":"","ref":"Abacus.Compile.html#add_use_bitwise/1"},{"type":"function","title":"Abacus.Compile.inject_comparison/1","doc":"","ref":"Abacus.Compile.html#inject_comparison/1"},{"type":"function","title":"Abacus.Compile.mfa/3","doc":"","ref":"Abacus.Compile.html#mfa/3"},{"type":"function","title":"Abacus.Compile.post_compile/2","doc":"","ref":"Abacus.Compile.html#post_compile/2"},{"type":"function","title":"Abacus.Compile.prepare_fn_calls/1","doc":"","ref":"Abacus.Compile.html#prepare_fn_calls/1"},{"type":"function","title":"Abacus.Compile.prepare_variables/1","doc":"","ref":"Abacus.Compile.html#prepare_variables/1"},{"type":"function","title":"Abacus.Compile.put_get_in/2","doc":"","ref":"Abacus.Compile.html#put_get_in/2"},{"type":"function","title":"Abacus.Compile.replace_operators/1","doc":"","ref":"Abacus.Compile.html#replace_operators/1"},{"type":"module","title":"Abacus.Format","doc":"\b\bFunction definitions on how to pretty-print expressions.\n\nSee `Abacus.format/1` for more information.","ref":"Abacus.Format.html"},{"type":"function","title":"Abacus.Format.format/1","doc":"","ref":"Abacus.Format.html#format/1"},{"type":"module","title":"Abacus.Runtime.Helpers","doc":"Utility functions","ref":"Abacus.Runtime.Helpers.html"},{"type":"function","title":"Abacus.Runtime.Helpers.cast_for_comparison/1","doc":"","ref":"Abacus.Runtime.Helpers.html#cast_for_comparison/1"},{"type":"function","title":"Abacus.Runtime.Helpers.compare/3","doc":"","ref":"Abacus.Runtime.Helpers.html#compare/3"},{"type":"function","title":"Abacus.Runtime.Helpers.compare/5","doc":"","ref":"Abacus.Runtime.Helpers.html#compare/5"},{"type":"function","title":"Abacus.Runtime.Helpers.factorial/1","doc":"Returns the factorial of n.","ref":"Abacus.Runtime.Helpers.html#factorial/1"},{"type":"function","title":"Example - Abacus.Runtime.Helpers.factorial/1","doc":"```\niex(2)> factorial(0)\n1\niex(3)> factorial(1)\n1\niex(4)> factorial(2)\n2\niex(5)> factorial(3)\n6\niex(6)> factorial(4)\n24\niex(7)> factorial(5)\n120\n```","ref":"Abacus.Runtime.Helpers.html#factorial/1-example"},{"type":"function","title":"Abacus.Runtime.Helpers.typeof/1","doc":"","ref":"Abacus.Runtime.Helpers.html#typeof/1"},{"type":"function","title":"Abacus.Runtime.Helpers.unescape_string/1","doc":"","ref":"Abacus.Runtime.Helpers.html#unescape_string/1"},{"type":"type","title":"Abacus.Runtime.Helpers.operator/0","doc":"","ref":"Abacus.Runtime.Helpers.html#t:operator/0"},{"type":"type","title":"Abacus.Runtime.Helpers.typeof/0","doc":"","ref":"Abacus.Runtime.Helpers.html#t:typeof/0"},{"type":"module","title":"Abacus.Runtime.Scope","doc":"Contains helper functions to work with the scope of an Abacus script at runtime","ref":"Abacus.Runtime.Scope.html"},{"type":"function","title":"Abacus.Runtime.Scope.default_scope/0","doc":"Returns a scope with some default functions and constants","ref":"Abacus.Runtime.Scope.html#default_scope/0"},{"type":"function","title":"Abacus.Runtime.Scope.get_in/3","doc":"Tries to get values from a subject.\n\nSubjects can be:\n\n * maps\n * keyword lists\n * lists (with integer keys)\n * nil (special case so access to undefined variables will not crash execution)\n\nKeys can be:\n\n * strings\n * atoms (you can pass a resolve map that converts the given atom key into a string key)\n * positive integers (for lists only)\n\nThe Abacus parser will reference this function extensively like this:\n\n`a.b[2]` will turn into\n\n```\nget_in(get_in(var0, :var1, var_lookup), 2, var_lookup)\n```\n\nin this case, `var_lookup` will be:\n\n```\n%{\n  var1: \"a\",\n  var2: \"b\"\n}\n```","ref":"Abacus.Runtime.Scope.html#get_in/3"},{"type":"function","title":"Abacus.Runtime.Scope.prepare_scope/2","doc":"Renames first-level variables into their respective `:\"var#{x}\"` atoms","ref":"Abacus.Runtime.Scope.html#prepare_scope/2"},{"type":"type","title":"Abacus.Runtime.Scope.index/0","doc":"","ref":"Abacus.Runtime.Scope.html#t:index/0"},{"type":"type","title":"Abacus.Runtime.Scope.key/0","doc":"","ref":"Abacus.Runtime.Scope.html#t:key/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}